!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!
!
!     #####################
      MODULE MODI_PPM_SCALAR
!     #####################
!
INTERFACE
!
      SUBROUTINE PPM_SCALAR (HLBCX,HLBCY, KSV, KTCOUNT,   &
                     PCRU, PCRV, PCRW, PTSTEP, PRHODJ,    &
                     PRHOX1, PRHOX2, PRHOY1, PRHOY2,      &
                     PRHOZ1, PRHOZ2,                      &
                     PSVT, PRSVS, HSV_ADV_SCHEME          ) 
!
USE MODD_ARGSLIST_ll, ONLY : HALO2LIST_ll
!
CHARACTER (LEN=4), DIMENSION(2), INTENT(IN) :: HLBCX ! X direction LBC type
CHARACTER (LEN=4), DIMENSION(2), INTENT(IN) :: HLBCY ! Y direction LBC type
CHARACTER (LEN=6),               INTENT(IN) :: HSV_ADV_SCHEME
!
INTEGER,                  INTENT(IN)    :: KSV    ! Number of Scalar Variables
INTEGER,                  INTENT(IN)    :: KTCOUNT! iteration count
!
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PCRU  ! Courant
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PCRV  ! numbers
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PCRW  ! 
!$acc declare present(PCRU,PCRV,PCRW)
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHODJ ! density
!$acc declare present(PRHODJ)
! Temporary advected rhodj
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHOX1,PRHOX2
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHOY1,PRHOY2
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHOZ1,PRHOZ2
!$acc declare present(PRHOX1,PRHOX2,PRHOY1,PRHOY2,PRHOZ1,PRHOZ2)
!
REAL,                     INTENT(IN)    :: PTSTEP ! Time step 
!
REAL, DIMENSION(:,:,:,:), INTENT(IN)    :: PSVT         ! Vars at t
!PW: bug workaround with PGI 15.10
!PSVT is present but if zero-size => not detected as present
!!$acc declare present(PSVT)
!$acc declare pcopyin(PSVT)
!
REAL, DIMENSION(:,:,:,:), INTENT(OUT) :: PRSVS ! Source terms
!PW: bug workaround with PGI 15.10
!PRSVS is present but if zero-size => not detected as present
!!$acc declare present(PRSVS)
!$acc declare pcopyout(PRSVS)
!
!
END SUBROUTINE PPM_SCALAR
!
END INTERFACE
!
END MODULE MODI_PPM_SCALAR
!
!     ######################################################################
#ifdef _OPENACC
      SUBROUTINE PPM_SCALAR (HLBCX,HLBCY, KSV, KTCOUNT,   &
                     PCRU, PCRV, PCRW, PTSTEP, PRHODJ,    &
                     PRHOX1, PRHOX2, PRHOY1, PRHOY2,      &
                     PRHOZ1, PRHOZ2,                      &
                     PSVT, PRSVS, HSV_ADV_SCHEME          ) 
  USE MODE_MNH_ZWORK, ONLY : ZT3D, MNH_GET_ZT3D , MNH_REL_ZT3D
  IMPLICIT NONE
!
!*       0.1   Declarations of dummy arguments :
!
CHARACTER (LEN=4), DIMENSION(2), INTENT(IN) :: HLBCX ! X direction LBC type
CHARACTER (LEN=4), DIMENSION(2), INTENT(IN) :: HLBCY ! Y direction LBC type
CHARACTER (LEN=6),               INTENT(IN) :: HSV_ADV_SCHEME
!
INTEGER,                  INTENT(IN)    :: KSV    ! Number of Scalar Variables
INTEGER,                  INTENT(IN)    :: KTCOUNT! iteration count
!
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PCRU  ! contravariant
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PCRV  !  components
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PCRW  ! of momentum
!$acc declare present(PCRU,PCRV,PCRW)
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHODJ ! density
!$acc declare present(PRHODJ)
! Temporary advected rhodj
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHOX1,PRHOX2
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHOY1,PRHOY2
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHOZ1,PRHOZ2
!$acc declare present(PRHOX1,PRHOX2,PRHOY1,PRHOY2,PRHOZ1,PRHOZ2)
!
REAL,                     INTENT(IN)    :: PTSTEP ! Time step 
!
REAL, DIMENSION(:,:,:,:), INTENT(IN)    :: PSVT             
!PW: bug workaround with PGI 15.10
!PSVT is present but if zero-size => not detected as present
!!$acc declare present(PSVT)
!$acc declare pcopyin(PSVT)
!
REAL, DIMENSION(:,:,:,:), INTENT(OUT) :: PRSVS         ! Source terms
!PW: bug workaround with PGI 15.10
!PRSVS is present but if zero-size => not detected as present
!!$acc declare present(PRSVS)
!$acc declare pcopyout(PRSVS)

         CALL  PPM_SCALAR_D (HLBCX,HLBCY, KSV, KTCOUNT,  &
                           & PCRU, PCRV, PCRW, PTSTEP, PRHODJ,  &
                           & PRHOX1, PRHOX2, PRHOY1, PRHOY2,     &
                           & PRHOZ1, PRHOZ2,                     &
                           & PSVT, PRSVS, HSV_ADV_SCHEME)

CONTAINS

      SUBROUTINE PPM_SCALAR_D (HLBCX,HLBCY, KSV, KTCOUNT,  &
                     & PCRU, PCRV, PCRW, PTSTEP, PRHODJ,   &
                     & PRHOX1, PRHOX2, PRHOY1, PRHOY2,     &
                     & PRHOZ1, PRHOZ2,                     &
                     & PSVT, PRSVS, HSV_ADV_SCHEME)
#else
      SUBROUTINE PPM_SCALAR (HLBCX,HLBCY, KSV, KTCOUNT,   &
                     PCRU, PCRV, PCRW, PTSTEP, PRHODJ,    &
                     PRHOX1, PRHOX2, PRHOY1, PRHOY2,      &
                     PRHOZ1, PRHOZ2,                      &
                     PSVT, PRSVS, HSV_ADV_SCHEME          ) 
#endif
!     ######################################################################
!
!!****  *PPM_SCALAR * 
!!
!!    PURPOSE
!!    -------
!!
!!**  METHOD
!!    ------
!!
!!    EXTERNAL
!!    --------
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    MODULE MODD_ARGSLIST
!!         HALO2LIST_ll : type for a list of "HALO2_lls"
!!
!!    REFERENCE
!!    ---------
!!
!!    AUTHOR
!!    ------
!!
!!    MODIFICATIONS
!!    -------------
!!      Original 11.05.2006. T.Maric
!!      Modification : 11.2011 C.Lac, V.Masson : Advection of (theta_l,r_t) 
!!
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
!USE MODE_ll
!
USE MODD_PARAMETERS
USE MODD_CONF
USE MODD_ARGSLIST_ll, ONLY : HALO2LIST_ll
!
USE MODI_SHUMAN
USE MODI_PPM
USE MODI_ADVEC_PPM_ALGO
!
!
IMPLICIT NONE
!
!*       0.1   Declarations of dummy arguments :
!
CHARACTER (LEN=4), DIMENSION(2), INTENT(IN) :: HLBCX ! X direction LBC type
CHARACTER (LEN=4), DIMENSION(2), INTENT(IN) :: HLBCY ! Y direction LBC type
CHARACTER (LEN=6),               INTENT(IN) :: HSV_ADV_SCHEME
!
INTEGER,                  INTENT(IN)    :: KSV    ! Number of Scalar Variables
INTEGER,                  INTENT(IN)    :: KTCOUNT! iteration count
!
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PCRU  ! contravariant
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PCRV  !  components
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PCRW  ! of momentum
!$acc declare present(PCRU,PCRV,PCRW)
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHODJ ! density
!$acc declare present(PRHODJ)
! Temporary advected rhodj
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHOX1,PRHOX2
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHOY1,PRHOY2
REAL, DIMENSION(:,:,:),   INTENT(IN)    :: PRHOZ1,PRHOZ2
!$acc declare present(PRHOX1,PRHOX2,PRHOY1,PRHOY2,PRHOZ1,PRHOZ2)
!
REAL,                     INTENT(IN)    :: PTSTEP ! Time step 
!
REAL, DIMENSION(:,:,:,:), INTENT(IN)    :: PSVT             
!$acc declare present(PSVT)
!
REAL, DIMENSION(:,:,:,:), INTENT(OUT) :: PRSVS         ! Source terms
!$acc declare present(PRSVS)
!
!
!*       0.2   Declarations of local variables :
!
INTEGER :: JSV           ! Loop index for Scalar Variables
!
INTEGER :: IGRID ! localisation on the model grid
!
!-------------------------------------------------------------------------------
!
!*       1.     CALL THE ADVEC_PPM_ALGO ROUTINE FOR EACH FIELD
!               -----------------------------------------------
!
IGRID = 1
!
! Case with KSV tracers
!
DO JSV=1,KSV
#ifdef _OPENACC
PRINT *,'OPENACC: ppm_scalar::KSV>0 not yet tested'
CALL ABORT
#endif
   CALL ADVEC_PPM_ALGO(HSV_ADV_SCHEME, HLBCX, HLBCY, IGRID, PSVT(:,:,:,JSV), & 
                       PRHODJ, PTSTEP, & 
                       PRHOX1, PRHOX2, PRHOY1, PRHOY2, PRHOZ1, PRHOZ2, &
                       PRSVS(:,:,:,JSV), KTCOUNT, PCRU, PCRV, PCRW)
END DO
!
#ifdef _OPENACC
END SUBROUTINE PPM_SCALAR_D
#endif
!
END SUBROUTINE PPM_SCALAR
